#!/bin/bash

sr_server=localhost
sr_site=demo
sr_user=automation
sr_pass=08212f80-bb65-4a37-a8c6-6afbdb935a58

###
#
# Host management
#
echo "Add first windows host ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Windows Server 1", "tag_agent": "cmk-agent", "ipaddress": "127.0.0.1"}, "hostname": "win-srv1", "folder": "windows"}'
echo

echo
echo "Add second windows host ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Windows Server 2", "tag_agent": "cmk-agent", "ipaddress": "127.0.0.1"}, "hostname": "win-srv2", "folder": "windows"}'
echo

echo
echo "Service discovery for host win-srv1 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=discover_services&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"hostname": "win-srv1"}'
echo

echo
echo "Service discovery for host win-srv2 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=discover_services&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"hostname": "win-srv2"}'
echo

echo
echo "Active changes ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=activate_changes&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"mode": "all"}'
echo

echo
echo "Add fist linux host ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Linux Server 1", "tag_agent": "cmk-agent", "ipaddress": "127.0.0.1"}, "hostname": "lnx-srv1", "folder": "linux"}'
echo

echo
echo "Add second linux host ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Linux Server 2", "tag_agent": "cmk-agent", "ipaddress": "127.0.0.1"}, "hostname": "lnx-srv2", "folder": "linux"}'
echo

echo
echo "Service discovery for host lnx-srv1 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=discover_services&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"hostname": "lnx-srv1"}'
echo

echo
echo "Service discovery for host lnx-srv2 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=discover_services&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"hostname": "lnx-srv2"}'
echo

echo
echo "Active changes ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=activate_changes&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"mode": "all"}'
echo

echo
echo "Add first node ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Node 1", "tag_agent": "cmk-agent", "ipaddress": "127.0.0.1"}, "hostname": "node1", "folder": "cluster"}'
echo

echo
echo "Add second node ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Node 2", "tag_agent": "cmk-agent", "ipaddress": "127.0.0.1"}, "hostname": "node2", "folder": "cluster"}'
echo

echo
echo "Add cluster host ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Cluster", "tag_agent": "ping", "ipaddress": "127.0.0.1"}, "hostname": "cluster", "nodes": ["node1", "node2"], "folder": "cluster"}'
echo

echo
echo "Service discovery for host node1 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=discover_services&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"hostname": "node1"}'
echo

echo
echo "Service discovery for host node2 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=discover_services&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"hostname": "node2"}'
echo

echo
echo "Active changes ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=activate_changes&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"mode": "all"}'
echo

echo
echo "Modify host cluster ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"tag_criticality": "critical"}, "unset_attributes": ["tag_agent"], "hostname": "cluster"}'
echo

echo
echo "Active changes ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=activate_changes&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"mode": "all"}'
echo

echo
echo "Edit host win-srv1 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Windows Server 1a"}, "unset_attributes":[], "hostname": "win-srv1"}'
echo

echo
echo "Edit host win-srv2 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Windows Server 2a"}, "unset_attributes":[], "hostname": "win-srv2"}'
echo

echo
echo "Edit host lnx-srv1 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Linux Server 1a"}, "unset_attributes":[], "hostname": "lnx-srv1"}'
echo

echo
echo "Edit host lnx-srv2 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"attributes":{"alias": "Linux Server 2a"}, "unset_attributes":[], "hostname": "lnx-srv2"}'
echo

echo
echo "Delete host win-srv1 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=delete_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"hostname": "win-srv1"}'
echo

echo
echo "Delete host lnx-srv1 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=delete_host&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"hostname": "lnx-srv1"}'
echo

echo
echo "Active changes ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=activate_changes&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"mode": "all"}'
echo

###
#
# Host groups
#
echo
echo "Get all host groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_hostgroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Add host group linux ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_hostgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "linux", "alias": "Linux Hosts"}'
echo

echo
echo "Add host group windows ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_hostgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "windows", "alias": "Windows Hosts"}'
echo

echo
echo "Get all host groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_hostgroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Edit host group linux ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_hostgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "linux", "alias": "Linux Hosts a"}'
echo

echo
echo "Edit host group windows ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_hostgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "windows", "alias": "Windows Hosts a"}'
echo

echo
echo "Get all host groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_hostgroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Delete host group linux ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=deletehostgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "linux"}'
echo

echo
echo "Get all host groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_hostgroups&_username=${sr_user}&_secret=${sr_pass}"
echo

###
#
# Service groups
#
echo
echo "Get all service groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_servicegroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Add service group filesystem ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_servicegroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "filesystem", "alias": "Filesystems"}'
echo

echo
echo "Add service group CPU ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_servicegroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "cpu", "alias": "CPU"}'
echo

echo
echo "Get all service groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_servicegroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Edit service group filesystem ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_servicegroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "filesystem", "alias": "Filesystems a"}'
echo

echo
echo "Edit service group CPU ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_servicegroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "cpu", "alias": "CPU a"}'
echo

echo
echo "Get all service groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_servicegroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Delete service group CPU ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=delete_servicegroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "cpu"}'
echo

echo
echo "Get all service groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_servicegroups&_username=${sr_user}&_secret=${sr_pass}"
echo

###
#
# Contact groups
#
echo
echo "Get all contact groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_contactgroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Add contact group linux ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_contactgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "linux", "alias": "Linux"}'
echo

echo
echo "Add contact group windows ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_contactgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "windows", "alias": "Windows"}'
echo

echo
echo "Get all contact groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_contactgroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Edit contact group linux ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_contactgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "linux", "alias": "Linux a"}'
echo

echo
echo "Edit contact group windows ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_contactgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "windows", "alias": "Windows a"}'
echo

echo
echo "Get all contact groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_contactgroups&_username=${sr_user}&_secret=${sr_pass}"
echo

echo
echo "Delete contact group windows ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=delete_contactgroup&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"groupname": "windows"}'
echo

echo
echo "Get all contact groups ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=get_all_contactgroups&_username=${sr_user}&_secret=${sr_pass}"
echo

###
#
# User management
#
echo
echo "Create three new local users ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=add_users&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"users": {"user1": {"alias": "Test User 1", "password": "123", "contactgroups": ["linux"]}, "user2": {"alias": "Test User 2", "password": "123", "contactgroups": ["windows"]}, "user3": {"alias": "Test User 3", "password": "123", "contactgroups": ["windows", "linux"]}}}'
echo

echo "Modify local user user3 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=edit_users&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"users":{"user3": { "set_attributes": { "alias": "Falscher User"}, "unset_attributes": ["contactgroups"]}}}'
echo

echo
echo "Delete local user user2, user3 ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=delete_users&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"users": ["user2", "user3"]}'
echo

echo
echo "Active changes ..."
curl "http://${sr_server}/${sr_site}/check_mk/webapi.py?action=activate_changes&_username=${sr_user}&_secret=${sr_pass}" -d \
'request={"mode": "all"}'
echo
